'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _yylibUi = require('yylib-ui');

var _reactRouter = require('react-router');

var _UrlUtils = require('yylib-utils/UrlUtils');

var _UrlUtils2 = _interopRequireDefault(_UrlUtils);

var _formatUtils = require('yylib-utils/formatUtils');

var _formatUtils2 = _interopRequireDefault(_formatUtils);

var _NccContext = require('yylib-utils/NccContext');

var _NccContext2 = _interopRequireDefault(_NccContext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var field = _yylibUi.YYClass.field,
    PropTypes = _yylibUi.YYClass.PropTypes;


function conv(dataItem, props) {
    var fieldtype = props.fieldtype,
        _props$format = props.format,
        format = _props$format === undefined ? "yyyy-MM-dd" : _props$format,
        _props$displayKey = props.displayKey,
        displayKey = _props$displayKey === undefined ? "name" : _props$displayKey,
        _props$trueDisplayVal = props.trueDisplayValue,
        trueDisplayValue = _props$trueDisplayVal === undefined ? "是" : _props$trueDisplayVal,
        _props$falseDisplayVa = props.falseDisplayValue,
        falseDisplayValue = _props$falseDisplayVa === undefined ? "否" : _props$falseDisplayVa,
        showDecimal = props.showDecimal,
        zeroFilling = props.zeroFilling,
        symbol = props.symbol,
        precisionConfig = props.precisionConfig;

    switch (fieldtype) {
        case "date":
            {
                return dataItem ? _formatUtils2.default.formatDate(_formatUtils2.default.parseAntDate(dataItem), format) : null;
            }
        case "object":
            {
                return dataItem ? dataItem[displayKey] : null;
            }
        case "boolean":
            {
                return dataItem ? trueDisplayValue : falseDisplayValue;
            }
        case "number":
            {
                if (!dataItem) {
                    // 为空显示0
                    dataItem = 0;
                }
                return _formatUtils2.default.formatNumber(dataItem, showDecimal, 3, dataItem, zeroFilling);
            }
        case "currency":
            {
                if (precisionConfig) {
                    var scales = _NccContext2.default.getScales(); // 精度参数值(暂只处理ncc的精度)
                    showDecimal = scales['' + precisionConfig];
                }
                if (!dataItem) {
                    // 为空显示0
                    dataItem = 0;
                }
                return _formatUtils2.default.formatNumber(dataItem, showDecimal, 3, dataItem, zeroFilling);
            }
        default:
            {
                return dataItem;
            }
    }
}

function noop() {}

var uiMeta = {
    name: 'ijz-listitem',
    fields: [
    //field 参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('prefixCls', 'ijz-listitem', PropTypes.string, false, '样式名前缀'), field('className', '', PropTypes.string, false, '样式'), field('dataItem', null, PropTypes.object, false, '行数据集')]
};

var uiMetaHeader = {
    name: 'ijz-listitem-header',
    fields: [
    //field 参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('prefixCls', 'ijz-listitem-header', PropTypes.string, false, '样式名前缀'), field('className', '', PropTypes.string, false, '样式'), field('renderItemHeaderLeft', null, PropTypes.func, false, '头部左侧区域自定义渲染'), field('renderItemHeaderRight', null, PropTypes.func, false, '头部右侧区域自定义渲染')]
};

var uiMetaContent = {
    name: 'ijz-listitem-content',
    fields: [
    //field 参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('prefixCls', 'ijz-listitem-content', PropTypes.string, false, '样式名前缀'), field('className', '', PropTypes.string, false, '样式'), field('renderItemContent', null, PropTypes.func, false, '中部区域自定义渲染'), field('itemContentCol', 2, PropTypes.number, true, '中间区域列数'), field('itemContentRowGutter', 16, PropTypes.number, true, '中间区域栅格间隔')]
};

var uiMetaFooter = {
    name: 'ijz-listitem-footer',
    fields: [
    //field 参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('prefixCls', 'ijz-listitem-footer', PropTypes.string, false, '样式名前缀'), field('className', '', PropTypes.string, false, '样式'), field('renderItemFooterLeft', null, PropTypes.func, false, '脚部左侧区域自定义渲染'), field('renderItemFooterRight', null, PropTypes.func, false, '脚部右侧区域自定义渲染')]
};

var uiMetaItem = {
    name: 'ijz-listitem-item',
    fields: [
    //field 参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('prefixCls', 'ijz-listitem-item', PropTypes.string, false, '样式名前缀'), field('className', '', PropTypes.string, false, '样式'), field('dataItem', null, PropTypes.object, false, '行数据集'), field('dataItemConv', conv, PropTypes.func, false, '(dataItem, props)=>{let _dataItem; return _dataItem}'), field('layout', 'left', PropTypes.oneOf(['left', 'right']), true, '显示布局'), field('type', 'label', PropTypes.oneOf(['label', 'label-item', 'hyperlink', 'tag', 'button']), true, '显示类型'), field('onClick', noop, PropTypes.func, false, '点击事件')]
};

var IjzListItem = _yylibUi.YYClass.create({
    uiMeta: uiMeta,

    displayName: 'IjzListItem',

    getInitialState: function getInitialState() {
        return {};
    },
    getClassName: function getClassName() {
        var prefixCls = this.props.prefixCls;

        return (0, _classnames2.default)(prefixCls);
    },
    render: function render() {
        var _props = this.props,
            className = _props.className,
            children = _props.children,
            dataItem = _props.dataItem,
            batchMode = _props.batchMode,
            otherProps = _objectWithoutProperties(_props, ['className', 'children', 'dataItem', 'batchMode']);

        return _react2.default.createElement(
            'div',
            _extends({}, otherProps, { className: (0, _classnames2.default)(this.getClassName(), className) }),
            _react2.default.Children.map(children, function (item) {
                if (_react2.default.isValidElement(item)) return _react2.default.cloneElement(item, {
                    dataItem: dataItem,
                    batchMode: batchMode
                });
            })
        );
    }
});

var ItemHeader = _yylibUi.YYClass.create({
    uiMeta: uiMetaHeader,

    getInitialState: function getInitialState() {
        return {};
    },
    getClassName: function getClassName() {
        var prefixCls = this.props.prefixCls;

        return (0, _classnames2.default)(prefixCls);
    },
    render: function render() {
        var _props2 = this.props,
            className = _props2.className,
            children = _props2.children,
            dataItem = _props2.dataItem,
            batchMode = _props2.batchMode,
            renderItemHeaderLeft = _props2.renderItemHeaderLeft,
            renderItemHeaderRight = _props2.renderItemHeaderRight,
            otherProps = _objectWithoutProperties(_props2, ['className', 'children', 'dataItem', 'batchMode', 'renderItemHeaderLeft', 'renderItemHeaderRight']);

        var leftContent = [];
        var rightContent = [];
        _react2.default.Children.map(children, function (item) {
            if (_react2.default.isValidElement(item) && item.type.displayName === 'IjzListItem-item' && item.props.layout === 'left') {
                leftContent.push(_react2.default.cloneElement(item, { dataItem: dataItem }));
            } else if (_react2.default.isValidElement(item) && item.type.displayName === 'IjzListItem-item' && item.props.layout === 'right') {
                rightContent.push(_react2.default.cloneElement(item, { dataItem: dataItem }));
            }
        });
        return _react2.default.createElement(
            'div',
            _extends({}, otherProps, { className: (0, _classnames2.default)(this.getClassName(), className) }),
            _react2.default.createElement(
                'div',
                {
                    className: batchMode === true ? this.getClassName() + '-left batchMode' : this.getClassName() + '-left' },
                renderItemHeaderLeft === undefined ? leftContent : renderItemHeaderLeft(dataItem)
            ),
            _react2.default.createElement(
                'div',
                { className: this.getClassName() + '-right' },
                renderItemHeaderRight === undefined ? rightContent : renderItemHeaderRight(dataItem)
            )
        );
    }
});

var ItemContent = _yylibUi.YYClass.create({
    uiMeta: uiMetaContent,

    getInitialState: function getInitialState() {
        return {};
    },
    getClassName: function getClassName() {
        var prefixCls = this.props.prefixCls;

        return (0, _classnames2.default)(prefixCls);
    },
    renderContent: function renderContent() {
        var _props3 = this.props,
            dataItem = _props3.dataItem,
            itemContentCol = _props3.itemContentCol,
            itemContentRowGutter = _props3.itemContentRowGutter,
            children = _props3.children;

        var content = [];
        var rowContext = [];
        var colSpan = 24 / itemContentCol;
        _react2.default.Children.map(children, function (item, index) {
            rowContext.push(_react2.default.createElement(
                _yylibUi.YYCol,
                { span: colSpan },
                _react2.default.cloneElement(item, { dataItem: dataItem, type: 'label-item-content' })
            ));
            if ((index + 1) % itemContentCol === 0) {
                content.push(_react2.default.createElement(
                    _yylibUi.YYRow,
                    { gutter: itemContentRowGutter },
                    [].concat(rowContext)
                ));
                rowContext.length = 0;
            }
        });
        while (rowContext.length < itemContentCol) {
            rowContext.push(_react2.default.createElement(_yylibUi.YYCol, { span: colSpan }));
        }
        if (rowContext.length > 0) {
            content.push(_react2.default.createElement(
                _yylibUi.YYRow,
                { gutter: itemContentRowGutter },
                [].concat(rowContext)
            ));
            rowContext.length = 0;
        }
        return content;
    },
    render: function render() {
        var _props4 = this.props,
            className = _props4.className,
            children = _props4.children,
            renderItemContent = _props4.renderItemContent,
            otherProps = _objectWithoutProperties(_props4, ['className', 'children', 'renderItemContent']);

        return _react2.default.createElement(
            'div',
            _extends({}, otherProps, { className: (0, _classnames2.default)(this.getClassName(), className) }),
            renderItemContent ? renderItemContent() : this.renderContent()
        );
    }
});

var ItemFooter = _yylibUi.YYClass.create({
    uiMeta: uiMetaFooter,

    getInitialState: function getInitialState() {
        return {};
    },
    getClassName: function getClassName() {
        var prefixCls = this.props.prefixCls;

        return (0, _classnames2.default)(prefixCls);
    },
    render: function render() {
        var _props5 = this.props,
            className = _props5.className,
            children = _props5.children,
            dataItem = _props5.dataItem,
            renderItemFooterLeft = _props5.renderItemFooterLeft,
            renderItemFooterRight = _props5.renderItemFooterRight,
            otherProps = _objectWithoutProperties(_props5, ['className', 'children', 'dataItem', 'renderItemFooterLeft', 'renderItemFooterRight']);

        var leftContent = [];
        var rightContent = [];
        _react2.default.Children.map(children, function (item) {
            if (_react2.default.isValidElement(item) && item.type.displayName === 'IjzListItem-item' && item.props.layout === 'left') {
                leftContent.push(_react2.default.cloneElement(item, { dataItem: dataItem }));
            } else if (_react2.default.isValidElement(item) && item.type.displayName === 'IjzListItem-item' && item.props.layout === 'right') {
                rightContent.push(_react2.default.cloneElement(item, { dataItem: dataItem }));
            }
        });

        return _react2.default.createElement(
            'div',
            _extends({}, otherProps, { className: (0, _classnames2.default)(this.getClassName(), className) }),
            _react2.default.createElement(
                'div',
                { className: this.getClassName() + '-left' },
                renderItemFooterLeft === undefined ? leftContent : renderItemFooterLeft(dataItem)
            ),
            _react2.default.createElement(
                'div',
                { className: this.getClassName() + '-right' },
                renderItemFooterRight === undefined ? rightContent : renderItemFooterRight(dataItem, rightContent)
            )
        );
    }
});

var Item = _yylibUi.YYClass.create({
    uiMeta: uiMetaItem,

    displayName: 'IjzListItem-item',

    getInitialState: function getInitialState() {
        return {};
    },
    getClassName: function getClassName() {
        var prefixCls = this.props.prefixCls;

        return (0, _classnames2.default)(prefixCls);
    },
    render: function render() {
        var _props6 = this.props,
            type = _props6.type,
            uikey = _props6.uikey,
            uititle = _props6.uititle,
            label = _props6.label,
            linkUrl = _props6.linkUrl,
            dataItem = _props6.dataItem,
            dataItemConv = _props6.dataItemConv,
            children = _props6.children,
            onClick = _props6.onClick,
            disabled = _props6.disabled,
            visible = _props6.visible,
            btnType = _props6.btnType,
            icon = _props6.icon,
            ghost = _props6.ghost;

        var defaultColor = "#bfbfbf";
        switch (type) {
            case 'label':
                {
                    var _text = dataItem === null ? uikey : dataItemConv(dataItem[uikey], this.props);
                    return _react2.default.createElement(
                        'div',
                        { className: (0, _classnames2.default)('label') },
                        _react2.default.createElement(
                            'span',
                            { title: _text },
                            _text
                        )
                    );
                }
            case 'label-item':
                {
                    var _text2 = dataItem === null ? uikey : dataItemConv(dataItem[uikey], this.props);
                    return _react2.default.createElement(
                        'div',
                        { className: (0, _classnames2.default)('label-item') },
                        _react2.default.createElement(
                            'span',
                            null,
                            label
                        ),
                        _react2.default.createElement(
                            'span',
                            { title: _text2 },
                            _text2
                        )
                    );
                }
            case 'label-item-content':
                {
                    var _text3 = dataItem === null ? uikey : dataItemConv(dataItem[uikey], this.props);
                    return _react2.default.createElement(
                        _yylibUi.YYRow,
                        { gutter: 6, className: (0, _classnames2.default)('label-item-content') },
                        _react2.default.createElement(
                            _yylibUi.YYCol,
                            { span: 8, className: (0, _classnames2.default)('label') },
                            _react2.default.createElement(
                                'span',
                                { title: label },
                                label
                            )
                        ),
                        _react2.default.createElement(
                            _yylibUi.YYCol,
                            { span: 14, className: (0, _classnames2.default)('data') },
                            _react2.default.createElement(
                                'span',
                                { title: _text3 },
                                _text3
                            )
                        )
                    );
                }
            case 'hyperlink':
                {
                    var _text4 = dataItem === null ? label : dataItem[uikey] ? dataItemConv(dataItem[uikey], this.props) : null;
                    return _react2.default.createElement(
                        'div',
                        { className: (0, _classnames2.default)('hyperlink') },
                        _react2.default.createElement(
                            _reactRouter.Link,
                            { title: _text4, to: _UrlUtils2.default.fillUrlParams(linkUrl, dataItem) },
                            _text4
                        )
                    );
                }
            case 'tag':
                {
                    var currState = dataItem === null ? undefined : _lodash2.default.find(children, function (o) {
                        var _o$props = o.props,
                            dataType = _o$props.dataType,
                            tagField = _o$props.tagField,
                            valueKey = _o$props.valueKey;

                        if (dataType === "object") {
                            return dataItem[uikey] && tagField === dataItem[uikey][valueKey];
                        } else if (dataType === "boolean") {
                            if (tagField === undefined) {
                                tagField = false;
                            }
                            return tagField === dataItem[uikey];
                        } else {
                            return tagField === dataItem[uikey];
                        }
                    });
                    currState = currState === undefined ? Object.create(null) : currState.props;
                    var _color = currState.color ? currState.color : defaultColor;
                    var _text5 = currState.uititle ? currState.uititle : uikey;
                    return _react2.default.createElement(
                        'span',
                        { title: _text5, style: { color: _color, borderColor: _color },
                            className: (0, _classnames2.default)('label-state') },
                        _text5
                    );
                }
            case 'button':
                {
                    return _react2.default.createElement(
                        _yylibUi.YYButton,
                        { className: (0, _classnames2.default)('button-state'), disabled: disabled, visible: visible, ghost: ghost,
                            type: btnType, icon: icon,
                            onClick: onClick.bind(null, dataItem) },
                        uititle
                    );
                }
            default:
                {
                    return null;
                }
        }
    }
});

module.exports = IjzListItem;
module.exports.IjzListItemHeader = ItemHeader;
module.exports.IjzListItemContent = ItemContent;
module.exports.IjzListItemFooter = ItemFooter;
module.exports.IjzListItemField2 = Item;